library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CLKDIV is
  generic ( WIDTH : integer :=  6;  
  	             N : integer := 36);

  port    (   CLK   : in  std_logic;
              DIV   : out std_logic );
end CLKDIV;

architecture RTL of CLKDIV is

signal DIV_REG : std_logic;
signal CNT : std_logic_vector( WIDTH - 1 downto 0 );

begin

DIV <= DIV_REG;

process( CLK ) begin
	if( CLK'event and CLK = '1') then
		if( CNT = N - 1 ) then
			CNT     <= (others=>'0');
			DIV_REG <= not DIV_REG;
		else
			CNT <= CNT + '1';
		end if; 
	end if; 
end process;

end RTL; 
