library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SELF_RST is
    Port ( CLK  : in  std_logic;
           RST  : in  std_logic;
           SIG  : in  std_logic_vector( 1 downto 0 );
           ENB  : out std_logic);
end SELF_RST;

architecture RTL of SELF_RST is

signal   STATE : std_logic_vector(1 downto 0);
constant S0    : std_logic_vector := "00";
constant S1    : std_logic_vector := "01";
constant S2    : std_logic_vector := "10";
constant S3    : std_logic_vector := "11"; 

begin

--***                 *--
--**  STATE MACHINE  **--
--*                 ***--
process( CLK, RST ) begin
	if( RST='1') then
		ENB <= '0';
	elsif( CLK'event and CLK='1') then
		case STATE is
			when S0 => 
				ENB   <= '0';
				if( SIG ="00" ) then
					STATE <= S1;
				end if;
			when S1 =>
				if( SIG ="01" ) then
					STATE <= S2;
				end if;
			when S2 => 
				if( SIG ="10" ) then
					STATE <= S3;
				end if;
			when S3 => 
				if( SIG ="11" ) then
					ENB   <= '1';
					STATE <= S0;
				end if;
			when others => STATE <= S0;
		end case;
	end if;
end process;

end RTL;

