library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity PLSGEN is
  generic ( WIDTH : integer :=  5;  
  	             N : integer := 18);

  port    (   CLK   : in  std_logic;
              STB   : out std_logic );
end PLSGEN;

architecture RTL of PLSGEN is

signal CNT : std_logic_vector( WIDTH - 1 downto 0 );

begin
process( CLK ) begin
	if( CLK'event and CLK = '1') then
		if( CNT = N - 1 ) then
			CNT <= (others=>'0');
			STB <= '1';
		else
			CNT <= CNT + '1';
			STB <= '0';
		end if; 
	end if; 
end process;
end RTL; 
